<template>
  <div class="navbar-expand-md">
    <b-collapse id="navbar-menu" class="navbar-collapse">
      <b-navbar type="light" toggleable="true">
        <div class="container-xl">
          <!-- left -->
          <b-navbar-nav>
            <b-nav-item
              to="/"
              :class="{ [activeClass('home')]: isActive('index') }"
            >
              <span class="nav-link-icon d-md-none d-lg-inline-block">
                <HomeIcon />
              </span>
              <span class="nav-link-title">Home</span>
            </b-nav-item>
            <b-nav-item-dropdown
              data-cy="dropdown-project-menu"
              :class="{ [activeClass('projects')]: isActive('projects') }"
            >
              <template #button-content>
                <span class="nav-link-icon d-md-none d-lg-inline-block">
                  <PackageIcon />
                </span>
                <span class="nav-link-title">Projects</span>
              </template>
              <b-dropdown-item
                data-cy="dropdown-project-menu-explorer"
                to="/projects"
              >
                <span class="nav-link-icon d-md-none d-lg-inline-block">
                  <ViewfinderIcon class="icon-xxs" />
                </span>
                Explore
              </b-dropdown-item>
              <b-dropdown-item
                v-b-modal.modal-create-project
                data-cy="dropdown-project-menu-create"
              >
                <span class="nav-link-icon d-md-none d-lg-inline-block">
                  <FolderPlusIcon class="icon-xxs" />
                </span>
                Create
              </b-dropdown-item>
              <!-- Create project modal here, because it's better to keep it close to its trigger -->
              <ModalsCreateProject
                id="modal-create-project"
                :header="false"
                :footer="false"
              />
              <!-- /Create project modal -->
            </b-nav-item-dropdown>
            <b-nav-item-dropdown
              :class="{ [activeClass('scenarios')]: isActive('scenarios') }"
            >
              <template #button-content>
                <span class="nav-link-icon d-md-none d-lg-inline-block">
                  <RouteIcon />
                </span>
                <span class="nav-link-title">Scenarios</span>
              </template>
              <b-dropdown-item to="/scenarios">
                <span class="nav-link-icon d-md-none d-lg-inline-block">
                  <ViewfinderIcon class="icon-xxs" />
                </span>
                Explore
              </b-dropdown-item>
            </b-nav-item-dropdown>
            <b-nav-item-dropdown
              :class="{ [activeClass('datasets')]: isActive('datasets') }"
            >
              <template #button-content>
                <span class="nav-link-icon d-md-none d-lg-inline-block">
                  <DatabaseIcon />
                </span>
                <span class="nav-link-title">Datasets</span>
              </template>
              <b-dropdown-item to="/datasets">
                <span class="nav-link-icon d-md-none d-lg-inline-block">
                  <ViewfinderIcon class="icon-xxs" />
                </span>
                Explore
              </b-dropdown-item>
            </b-nav-item-dropdown>
            <b-nav-item-dropdown
              :class="{
                [activeClass('access-requests')]: isActive('access-requests'),
              }"
            >
              <template #button-content>
                <span class="nav-link-icon d-md-none d-lg-inline-block">
                  <FileExportIcon />
                </span>
                <span class="nav-link-title">Access Requests</span>
              </template>
              <b-dropdown-item
                v-if="
                  hasRole('Access Request Evaluator') || hasRole('Super Admin')
                "
                to="/access-request/list/evaluations"
              >
                <span class="nav-link-icon d-md-none d-lg-inline-block">
                  <FileLikeIcon class="icon-xxs" />
                </span>
                My Evaluations
              </b-dropdown-item>
              <b-dropdown-item to="/access-request/datasets">
                <span class="nav-link-icon d-md-none d-lg-inline-block">
                  <DatabaseIcon class="icon-xxs" />
                </span>
                All Risis Datasets
              </b-dropdown-item>
              <b-dropdown-item to="/access-request/new">
                <span class="nav-link-icon d-md-none d-lg-inline-block">
                  <FolderPlusIcon class="icon-xxs" />
                </span>
                Create an Access Request
              </b-dropdown-item>
              <b-dropdown-item
                v-if="hasRole('Access Request Admin') || hasRole('Super Admin')"
                to="/access-request/list/all"
              >
                <span class="nav-link-icon d-md-none d-lg-inline-block">
                  <ListSearchIcon class="icon-xxs" />
                </span>
                All Access Requests
              </b-dropdown-item>
              <b-dropdown-item to="/access-request/list">
                <span class="nav-link-icon d-md-none d-lg-inline-block">
                  <ListIcon class="icon-xxs" />
                </span>
                My Access Requests
              </b-dropdown-item>
            </b-nav-item-dropdown>
            <b-nav-item-dropdown v-if="flags.ADVANCED_MODE" disabled>
              <template #button-content>
                <span class="nav-link-icon d-md-none d-lg-inline-block">
                  <TemplateIcon />
                </span>
                <span class="nav-link-title">Console</span>
              </template>
              <b-dropdown-item>
                <span class="nav-link-icon d-md-none d-lg-inline-block">
                  <ActivityIcon class="icon-xxs" />
                </span>
                Tasks
              </b-dropdown-item>
              <b-dropdown-item>
                <span class="nav-link-icon d-md-none d-lg-inline-block">
                  <ListIcon class="icon-xxs" />
                </span>
                Logs
              </b-dropdown-item>
            </b-nav-item-dropdown>
            <b-nav-item v-if="flags.ADVANCED_MODE" disabled>
              <span class="nav-link-icon d-md-none d-lg-inline-block">
                <FolderIcon />
              </span>
              <span class="nav-link-title">Storage</span>
            </b-nav-item>
            <b-nav-item v-if="flags.ADVANCED_MODE" disabled>
              <span class="nav-link-icon d-md-none d-lg-inline-block">
                <AppsIcon />
              </span>
              <span class="nav-link-title">Providers</span>
            </b-nav-item>
          </b-navbar-nav>
          <!-- /left -->
          <!-- right -->
          <div
            class="my-2 my-md-0 flex-grow-1 flex-md-grow-0 order-first order-md-last"
          >
            <div class="input-icon">
              <span class="input-icon-addon">
                <SearchIcon />
              </span>
              <input
                v-b-modal.modal-search-workspace
                data-cy="search-workspace"
                type="text"
                class="form-control"
                placeholder="Search in workspace…"
              />
            </div>
            <ModalsSearchWorkspace
              id="modal-search-workspace"
              :visible="modalSearchWorkspaceVisible"
              @hidden="searchWorkspaceModalHidden()"
              @shown="searchWorkspaceModalShown()"
            />
            <ModalsImportIntoProject id="modal-import-into-project" />
          </div>
          <!-- /right -->
        </div>
      </b-navbar>
    </b-collapse>
    <ModalsCreateDataset
      id="modal-create-dataset"
      :visible="modalDatasetVisible"
      @hidden="datasetModalHidden()"
      @shown="datasetModalShown()"
    />
  </div>
</template>

<script>
import { mapState } from 'vuex';

export default {
  data() {
    return {
      roles: null,
    };
  },
  computed: {
    ...mapState(['flags']),
    modalDatasetVisible() {
      const modalData =
        this.$nuxt.context.store.getters['ui/datasetCreateModal'];
      return modalData.visible;
    },
    modalSearchWorkspaceVisible() {
      const modalData =
        this.$nuxt.context.store.getters['ui/searchWorkspaceModal'];
      return modalData.visible;
    },
  },
  mounted() {
    function parseJwt(token) {
      return JSON.parse(Buffer.from(token.split('.')[1], 'base64').toString());
    }
    const token = this.$auth.strategy.token.get().split(' ');
    this.roles = parseJwt(token[1]).realm_access.roles;
  },
  methods: {
    isActive(item) {
      const parts = this.$nuxt.$route.name
        ? this.$nuxt.$route.name.split('-')
        : [];
      return parts[0] === item;
    },
    hasRole(role) {
      return this.roles && this.roles.includes(role);
    },
    activeClass(item) {
      return `active active-${item}`;
    },
    datasetModalHidden() {
      this.$store.commit('ui/setDatasetCreateVisible', false);
    },
    datasetModalShown() {
      this.$store.commit('ui/setDatasetCreateVisible', true);
    },
    searchWorkspaceModalHidden() {
      this.$store.commit('ui/setSearchWorkspaceVisible', false);
    },
    searchWorkspaceModalShown() {
      this.$store.commit('ui/setSearchWorkspaceVisible', true);
    },
  },
};
</script>
